#!env python
"""
Copyright (C) 2000 Frdric Laurent

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

mailto:flrt@free.fr
"""

from pawt import swing
from java import awt

from java.awt.event import ActionListener
from java.awt.event import MouseAdapter
from java.awt.event import WindowAdapter
from java.awt import Dimension

import pyFind
import java
import sys
import FindData
import SwingAdapter
import os
import string


class DbclickListener(MouseAdapter):
	def __init__(self, frame):
		self.frameSource = frame
	
	def mouseClicked(self, event):
		if (event.getClickCount() == 2):
			self.frameSource.locationSelected(event.getPoint())


class ExitListener(WindowAdapter):
	def __init__(self):
		WindowAdapter.__init__(self)
	def windowClosing(self, e):
		java.lang.System.exit(0)



class FindGui(swing.JFrame, ActionListener):
	def __init__(self,title):
		swing.JFrame.__init__(self,title, visible=1)
		self.dataModel = FindData.FindDataModel()
		self.foundlist = None
		self.finder = pyFind.FileFind()
		self.addWindowListener(ExitListener())

	def getPreferredSize(self): return Dimension(400,400)

	def buildData(self):
		self.dataModel.clear()
		for i in self.finder.getFoundFiles():
			self.dataModel.addElement(i)
		self.dataModel.updateData()

	
	def buildGui(self):
  		# label
  		labelPanel = swing.JPanel(layout=awt.GridLayout(3,0))
  		labelPanel.add(swing.JLabel("o"))
  		labelPanel.add(swing.JLabel("quoi"))
  		labelPanel.add(swing.JLabel("faire"))
		
  		# textfield
  		textPanel = swing.JPanel(layout=awt.GridLayout(3,0))
  		self.whereText = swing.JTextField()
  		self.whatText = swing.JTextField()
  		self.bindingText = swing.JTextField()
  		textPanel.add(self.whereText)
  		textPanel.add(self.whatText)
  		textPanel.add(self.bindingText)
		
  		# button
  		fctPanel = swing.JPanel(layout=awt.GridLayout(2,0))
  		self.searchButton = swing.JButton("Recherche")
  		self.searchButton.addActionListener(self)
		
  		fctPanel.add(self.searchButton)
		
  		topPanel = swing.JPanel(layout=awt.BorderLayout())
  		topPanel.setBackground(awt.Color.gray)
  		topPanel.add("West",labelPanel)
  		topPanel.add("Center",textPanel)
  		topPanel.add("East",fctPanel)
		
  		# list
  		self.foundlist = swing.JList(self.dataModel)
  		self.foundlist.setCellRenderer(SwingAdapter.FindListRenderer())
  		scrollp = swing.JScrollPane(self.foundlist)
  		dbc = DbclickListener(self)
  		self.foundlist.addMouseListener(dbc)
		
  		self.contentPane.setLayout(awt.BorderLayout())
  		self.contentPane.add("North",topPanel)
		self.contentPane.add("Center",scrollp)
		
  		self.pack()


	def actionPerformed(self, event):
		if (event.getSource()==self.searchButton):
			self.finder.setPath(self.whereText.getText())
			self.finder.setExprFile(self.whatText.getText())
			self.finder.process()
			self.buildData()

	def locationSelected(self, point):
		if len(self.bindingText.getText()):
			index = self.foundlist.locationToIndex(point)
			val = self.dataModel.getElementAt(index)
			cmd = self.bindingText.getText()+" "+self.whereText.getText()+os.sep+val
			try:
				java.lang.Runtime.getRuntime().exec(cmd)
			except java.io.IOException:
				print "Erreur execution "


		
if __name__=="__main__":
	pf = pyFind.FileFind()
	frame = FindGui('Recherche...')
	
	frame.buildGui()
	frame.buildData()

			


